package com.docus.server.common.process;

import com.docus.core.util.Func;
import com.docus.log.context.TrackContext;
import com.docus.log.processor.AbstractProcessor;
import com.docus.server.common.netty.server.ChannelRepository;
import com.docus.server.dto.scheduling.management.schterminator.EditSchTerminatorDTO;
import com.docus.server.dto.scheduling.management.schterminator.NettyTerminatorDTO;
import com.docus.server.service.ISchTerminatorService;
import com.docus.server.vo.scheduling.management.schterminator.SchTerminatorVO;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * channel 管理
 */
public class ChannelProcessor extends AbstractProcessor {
    @Resource
    private ChannelRepository channelRepository;
    @Resource
    private ISchTerminatorService iSchTerminatorService;

    @Override
    protected Object doProcess(TrackContext context) {
        return logProcess(context);
    }

    private boolean logProcess(TrackContext context) {
        boolean error = context.isError();
        EditSchTerminatorDTO terminatorDTO = (EditSchTerminatorDTO) context.getArgs()[0];
        if (!error) {
            SchTerminatorVO terminatorVO = iSchTerminatorService.findById(String.valueOf(terminatorDTO.getId()));

            NettyTerminatorDTO nettyTerminatorDTO = channelRepository.getTerminatorByIp(terminatorVO.getTerminatorIp());

            if (Func.isNotBlank(terminatorDTO.getOnlyCollectorIds())) {
                List<String> onlyList = Arrays.stream(terminatorDTO.getOnlyCollectorIds().split(",")).map(String::valueOf).collect(Collectors.toList());
                nettyTerminatorDTO.setOnlyCollectorIds(onlyList);
            }
            if (Func.isNotBlank(terminatorDTO.getPriorityCollectorIds())) {
                List<String> priList = Arrays.stream(terminatorDTO.getPriorityCollectorIds().split(",")).map(String::valueOf).collect(Collectors.toList());
                nettyTerminatorDTO.setPriorityCollectorIds(priList);
            }
        }
        return error;
    }
}
